diff --git a/sys/net/pfil.c b/sys/net/pfil.c
index 8f9b4a3..6278664 100644
--- a/sys/net/pfil.c
+++ b/sys/net/pfil.c
@@ -269,7 +269,8 @@ pfil_add_hook(pfil_func_t func, void *arg, int flags, struct pfil_head *ph)
 	struct netmsg *nmsg;
 
 	nmsg = &pfilmsg.pfil_nmsg;
-	netmsg_init(nmsg, &curthread->td_msgport, 0, pfil_add_hook_dispatch);
+	netmsg_init(nmsg, NULL, &curthread->td_msgport,
+		    0, pfil_add_hook_dispatch);
 	pfilmsg.pfil_func = func;
 	pfilmsg.pfil_arg = arg;
 	pfilmsg.pfil_flags = flags;
@@ -370,7 +371,8 @@ pfil_remove_hook(pfil_func_t func, void *arg, int flags, struct pfil_head *ph)
 	struct netmsg *nmsg;
 
 	nmsg = &pfilmsg.pfil_nmsg;
-	netmsg_init(nmsg, &curthread->td_msgport, 0, pfil_remove_hook_dispatch);
+	netmsg_init(nmsg, NULL, &curthread->td_msgport,
+		    0, pfil_remove_hook_dispatch);
 	pfilmsg.pfil_func = func;
 	pfilmsg.pfil_arg = arg;
 	pfilmsg.pfil_flags = flags;
diff --git a/sys/net/route.c b/sys/net/route.c
index b014dfb..74958b5 100644
--- a/sys/net/route.c
+++ b/sys/net/route.c
@@ -179,7 +179,8 @@ rtable_init(void)
 {
 	struct netmsg nmsg;
 
-	netmsg_init(&nmsg, &curthread->td_msgport, 0, rtable_init_oncpu);
+	netmsg_init(&nmsg, NULL, &curthread->td_msgport,
+		    0, rtable_init_oncpu);
 	ifnet_domsg(&nmsg.nm_lmsg, 0);
 }
 
@@ -386,7 +387,8 @@ rtfree_remote(struct rtentry *rt, int allow_panic)
 		print_backtrace();
 	}
 
-	netmsg_init(&nmsg, &curthread->td_msgport, 0, rtfree_remote_dispatch);
+	netmsg_init(&nmsg, NULL, &curthread->td_msgport,
+		    0, rtfree_remote_dispatch);
 	lmsg = &nmsg.nm_lmsg;
 	lmsg->u.ms_resultp = rt;
 
@@ -524,8 +526,8 @@ rtredirect(struct sockaddr *dst, struct sockaddr *gateway,
 #ifdef SMP
 	struct netmsg_rtredirect msg;
 
-	netmsg_init(&msg.netmsg, &curthread->td_msgport, 0,
-		    rtredirect_msghandler);
+	netmsg_init(&msg.netmsg, NULL, &curthread->td_msgport,
+		    0, rtredirect_msghandler);
 	msg.dst = dst;
 	msg.gateway = gateway;
 	msg.netmask = netmask;
@@ -744,8 +746,8 @@ rtrequest1_global(int req, struct rt_addrinfo *rtinfo,
 #ifdef SMP
 	struct netmsg_rtq msg;
 
-	netmsg_init(&msg.netmsg, &curthread->td_msgport, 0,
-		    rtrequest1_msghandler);
+	netmsg_init(&msg.netmsg, NULL, &curthread->td_msgport,
+		    0, rtrequest1_msghandler);
 	msg.netmsg.nm_lmsg.ms_error = -1;
 	msg.req = req;
 	msg.rtinfo = rtinfo;
@@ -1660,8 +1662,8 @@ rtsearch_global(int req, struct rt_addrinfo *rtinfo,
 {
 	struct netmsg_rts msg;
 
-	netmsg_init(&msg.netmsg, &curthread->td_msgport, 0,
-		    rtsearch_msghandler);
+	netmsg_init(&msg.netmsg, NULL, &curthread->td_msgport,
+		    0, rtsearch_msghandler);
 	msg.req = req;
 	msg.rtinfo = rtinfo;
 	msg.callback = callback;
@@ -1773,8 +1775,8 @@ rtmask_add_global(struct sockaddr *mask)
 {
 	struct netmsg nmsg;
 
-	netmsg_init(&nmsg, &curthread->td_msgport, 0,
-		    rtmask_add_msghandler);
+	netmsg_init(&nmsg, NULL, &curthread->td_msgport,
+		    0, rtmask_add_msghandler);
 	nmsg.nm_lmsg.u.ms_resultp = mask;
 
 	return lwkt_domsg(rtable_portfn(0), &nmsg.nm_lmsg, 0);
diff --git a/sys/net/rtsock.c b/sys/net/rtsock.c
index e437e09..b2011c4 100644
--- a/sys/net/rtsock.c
+++ b/sys/net/rtsock.c
@@ -374,9 +374,9 @@ rts_input_skip(struct mbuf *m, sa_family_t family, struct rawcb *skip)
 
 	M_ASSERTPKTHDR(m);
 
-	port = cpu0_soport(NULL, NULL, NULL, 0);
+	port = cpu0_soport(NULL, NULL, NULL); /* same as for routing socket */
 	pmsg = &m->m_hdr.mh_netmsg;
-	netmsg_init(&pmsg->nm_netmsg, &netisr_apanic_rport, 
+	netmsg_init(&pmsg->nm_netmsg, NULL, &netisr_apanic_rport, 
 		    0, rts_input_handler);
 	pmsg->nm_packet = m;
 	pmsg->nm_netmsg.nm_lmsg.u.ms_result = family;
diff --git a/sys/net/vlan/if_vlan.c b/sys/net/vlan/if_vlan.c
index 9cd0bcd..6355d88 100644
--- a/sys/net/vlan/if_vlan.c
+++ b/sys/net/vlan/if_vlan.c
@@ -373,7 +373,8 @@ vlan_ifdetach(void *arg __unused, struct ifnet *ifp)
 	bzero(&vmsg, sizeof(vmsg));
 	nmsg = &vmsg.nv_nmsg;
 
-	netmsg_init(nmsg, &curthread->td_msgport, 0, vlan_ifdetach_dispatch);
+	netmsg_init(nmsg, NULL, &curthread->td_msgport,
+		    0, vlan_ifdetach_dispatch);
 	vmsg.nv_ifp_p = ifp;
 
 	lwkt_domsg(cpu_portfn(0), &nmsg->nm_lmsg, 0);
@@ -497,7 +498,8 @@ vlan_start(struct ifnet *ifp)
 		nmp = &m->m_hdr.mh_netmsg;
 		nmsg = &nmp->nm_netmsg;
 
-		netmsg_init(nmsg, &netisr_apanic_rport, 0, vlan_start_dispatch);
+		netmsg_init(nmsg, NULL, &netisr_apanic_rport,
+			    0, vlan_start_dispatch);
 		nmp->nm_packet = m;
 		nmsg->nm_lmsg.u.ms_resultp = ifp_p;
 
@@ -604,7 +606,8 @@ vlan_link(struct ifvlan *ifv, struct ifnet *ifp_p)
 	bzero(&vmsg, sizeof(vmsg));
 	nmsg = &vmsg.nv_nmsg;
 
-	netmsg_init(nmsg, &curthread->td_msgport, 0, vlan_link_dispatch);
+	netmsg_init(nmsg, NULL, &curthread->td_msgport,
+		    0, vlan_link_dispatch);
 	vmsg.nv_ifv = ifv;
 	vmsg.nv_ifp_p = ifp_p;
 
@@ -713,7 +716,8 @@ vlan_config(struct ifvlan *ifv, const char *parent_name, uint16_t vlantag)
 	bzero(&vmsg, sizeof(vmsg));
 	nmsg = &vmsg.nv_nmsg;
 
-	netmsg_init(nmsg, &curthread->td_msgport, 0, vlan_config_dispatch);
+	netmsg_init(nmsg, NULL, &curthread->td_msgport,
+		    0, vlan_config_dispatch);
 	vmsg.nv_ifv = ifv;
 	vmsg.nv_parent_name = parent_name;
 	vmsg.nv_vlantag = vlantag;
@@ -756,7 +760,8 @@ vlan_unlink(struct ifvlan *ifv, struct ifnet *ifp_p)
 	bzero(&vmsg, sizeof(vmsg));
 	nmsg = &vmsg.nv_nmsg;
 
-	netmsg_init(nmsg, &curthread->td_msgport, 0, vlan_unlink_dispatch);
+	netmsg_init(nmsg, NULL, &curthread->td_msgport,
+		    0, vlan_unlink_dispatch);
 	vmsg.nv_ifv = ifv;
 	vmsg.nv_ifp_p = ifp_p;
 
@@ -855,7 +860,8 @@ vlan_unconfig(struct ifvlan *ifv)
 	bzero(&vmsg, sizeof(vmsg));
 	nmsg = &vmsg.nv_nmsg;
 
-	netmsg_init(nmsg, &curthread->td_msgport, 0, vlan_unconfig_dispatch);
+	netmsg_init(nmsg, NULL, &curthread->td_msgport,
+		    0, vlan_unconfig_dispatch);
 	vmsg.nv_ifv = ifv;
 
 	return lwkt_domsg(cpu_portfn(0), &nmsg->nm_lmsg, 0);
@@ -998,7 +1004,8 @@ vlan_config_multi(struct ifvlan *ifv)
 	bzero(&vmsg, sizeof(vmsg));
 	nmsg = &vmsg.nv_nmsg;
 
-	netmsg_init(nmsg, &curthread->td_msgport, 0, vlan_multi_dispatch);
+	netmsg_init(nmsg, NULL, &curthread->td_msgport,
+		    0, vlan_multi_dispatch);
 	vmsg.nv_ifv = ifv;
 
 	return lwkt_domsg(cpu_portfn(0), &nmsg->nm_lmsg, 0);
@@ -1031,7 +1038,8 @@ vlan_config_flags(struct ifvlan *ifv)
 	bzero(&vmsg, sizeof(vmsg));
 	nmsg = &vmsg.nv_nmsg;
 
-	netmsg_init(nmsg, &curthread->td_msgport, 0, vlan_flags_dispatch);
+	netmsg_init(nmsg, NULL, &curthread->td_msgport,
+		    0, vlan_flags_dispatch);
 	vmsg.nv_ifv = ifv;
 
 	return lwkt_domsg(cpu_portfn(0), &nmsg->nm_lmsg, 0);
diff --git a/sys/netinet/if_ether.c b/sys/netinet/if_ether.c
index d922ce9..5667b9b 100644
--- a/sys/netinet/if_ether.c
+++ b/sys/netinet/if_ether.c
@@ -430,8 +430,8 @@ arprequest_async(struct ifnet *ifp, const struct in_addr *sip,
 		return;
 
 	pmsg = &m->m_hdr.mh_netmsg;
-	netmsg_init(&pmsg->nm_netmsg, &netisr_apanic_rport, 0,
-		    arpreq_send_handler);
+	netmsg_init(&pmsg->nm_netmsg, NULL, &netisr_apanic_rport,
+		    0, arpreq_send_handler);
 	pmsg->nm_packet = m;
 	pmsg->nm_netmsg.nm_lmsg.u.ms_resultp = ifp;
 
@@ -744,7 +744,8 @@ arp_update_oncpu(struct mbuf *m, in_addr_t saddr, boolean_t create,
 			rt->rt_refcnt++;
 
 			pmsg = &m->m_hdr.mh_netmsg;
-			netmsg_init(&pmsg->nm_netmsg, &netisr_apanic_rport,
+			netmsg_init(&pmsg->nm_netmsg, NULL,
+				    &netisr_apanic_rport,
 				    MSGF_MPSAFE | MSGF_PRIORITY,
 				    arp_hold_output);
 			pmsg->nm_packet = m;
@@ -908,8 +909,8 @@ match:
 	if (ifp->if_flags & IFF_STATICARP)
 		goto reply;
 #ifdef SMP
-	netmsg_init(&msg.netmsg, &curthread->td_msgport, 0, 
-		    arp_update_msghandler);
+	netmsg_init(&msg.netmsg, NULL, &curthread->td_msgport,
+		    0, arp_update_msghandler);
 	msg.m = m;
 	msg.saddr = isaddr.s_addr;
 	msg.create = (itaddr.s_addr == myaddr.s_addr);
diff --git a/sys/netinet/in.c b/sys/netinet/in.c
index 43d265a..6a9a764 100644
--- a/sys/netinet/in.c
+++ b/sys/netinet/in.c
@@ -260,8 +260,8 @@ in_control(struct socket *so, u_long cmd, caddr_t data, struct ifnet *ifp,
 		arg.ifp = ifp;
 		arg.td = td;
 
-		netmsg_init(&nmsg, &curthread->td_msgport, 0,
-			    in_control_dispatch);
+		netmsg_init(&nmsg, NULL, &curthread->td_msgport,
+			    0, in_control_dispatch);
 		msg = &nmsg.nm_lmsg;
 		msg->u.ms_resultp = &arg;
 
@@ -379,7 +379,8 @@ in_ialink(struct in_ifaddr *ia)
 	struct netmsg nmsg;
 	struct lwkt_msg *lmsg;
 
-	netmsg_init(&nmsg, &curthread->td_msgport, 0, in_ialink_dispatch);
+	netmsg_init(&nmsg, NULL, &curthread->td_msgport,
+		    0, in_ialink_dispatch);
 	lmsg = &nmsg.nm_lmsg;
 	lmsg->u.ms_resultp = ia;
 
@@ -392,7 +393,8 @@ in_iaunlink(struct in_ifaddr *ia)
 	struct netmsg nmsg;
 	struct lwkt_msg *lmsg;
 
-	netmsg_init(&nmsg, &curthread->td_msgport, 0, in_iaunlink_dispatch);
+	netmsg_init(&nmsg, NULL, &curthread->td_msgport,
+		    0, in_iaunlink_dispatch);
 	lmsg = &nmsg.nm_lmsg;
 	lmsg->u.ms_resultp = ia;
 
@@ -405,7 +407,8 @@ in_iahash_insert(struct in_ifaddr *ia)
 	struct netmsg nmsg;
 	struct lwkt_msg *lmsg;
 
-	netmsg_init(&nmsg, &curthread->td_msgport, 0, in_iahashins_dispatch);
+	netmsg_init(&nmsg, NULL, &curthread->td_msgport,
+		    0, in_iahashins_dispatch);
 	lmsg = &nmsg.nm_lmsg;
 	lmsg->u.ms_resultp = ia;
 
@@ -418,7 +421,8 @@ in_iahash_remove(struct in_ifaddr *ia)
 	struct netmsg nmsg;
 	struct lwkt_msg *lmsg;
 
-	netmsg_init(&nmsg, &curthread->td_msgport, 0, in_iahashrem_dispatch);
+	netmsg_init(&nmsg, NULL, &curthread->td_msgport,
+		    0, in_iahashrem_dispatch);
 	lmsg = &nmsg.nm_lmsg;
 	lmsg->u.ms_resultp = ia;
 
diff --git a/sys/netinet/ip_demux.c b/sys/netinet/ip_demux.c
index 767aa7c..046ebba 100644
--- a/sys/netinet/ip_demux.c
+++ b/sys/netinet/ip_demux.c
@@ -385,35 +385,25 @@ ip_mport_pktinfo(const struct pktinfo *pi, struct mbuf *m)
 }
 
 /*
- * Map a TCP socket to a protocol processing thread.
+ * Initital port when creating the socket, generally before
+ * binding or connect.
  */
 lwkt_port_t
-tcp_soport(struct socket *so, struct sockaddr *nam __unused,
-	   struct mbuf **dummy __unused, int req)
+tcp_soport_attach(struct socket *so)
 {
-	struct inpcb *inp;
-
-	/* The following processing all take place on Protocol Thread 0. */
-	if (req == PRU_BIND || req == PRU_CONNECT || req == PRU_ATTACH ||
-	    req == PRU_LISTEN)
-		return (&tcp_thread[0].td_msgport);
-
-	inp = so->so_pcb;
-	if (!inp)		/* connection reset by peer */
-		return (&tcp_thread[0].td_msgport);
+	return(&tcp_thread[0].td_msgport);
+}
 
-	/*
-	 * Already bound and connected or listening.  For TCP connections,
-	 * the (faddr, fport, laddr, lport) association cannot change now.
-	 *
-	 * Note: T/TCP code needs some reorganization to fit into
-	 * this model.  XXX JH
-	 *
-	 * Rely on type-stable memory and check in protocol handler
-	 * to fix race condition here w/ deallocation of inp.  XXX JH
-	 */
-	return (&tcp_thread[INP_MPORT_HASH_TCP(inp->inp_faddr.s_addr,
-	    inp->inp_laddr.s_addr, inp->inp_fport, inp->inp_lport)].td_msgport);
+/*
+ * This is used to map a socket to a message port for sendmsg() and friends.
+ * It is not called for any other purpose.  In the case of TCP we just return
+ * the port already installed in the socket.
+ */
+lwkt_port_t
+tcp_soport(struct socket *so, struct sockaddr *nam,
+	   struct mbuf **dummy __unused)
+{
+	return(so->so_port);
 }
 
 /*
@@ -468,38 +458,35 @@ tcp_addrport0(void)
 	return (&tcp_thread[0].td_msgport);
 }
 
+lwkt_port_t
+udp_addrport(in_addr_t faddr, in_port_t fport, in_addr_t laddr, in_port_t lport)
+{
+	return (&udp_thread[udp_addrcpu(faddr, fport,
+					laddr, lport)].td_msgport);
+}
+
 /*
- * Map a UDP socket to a protocol processing thread.
+ * Initital port when creating the socket, generally before
+ * binding or connect.
  */
 lwkt_port_t
-udp_soport(struct socket *so, struct sockaddr *nam __unused,
-	   struct mbuf **dummy __unused, int req)
+udp_soport_attach(struct socket *so)
 {
-	struct inpcb *inp;
-
-	/*
-	 * The following processing all take place on Protocol Thread 0:
-	 *   bind()
-	 *   attach() has a null socket parameter
-	 *   Fast and slow timeouts pass in null socket parameter
-	 */
-	if (req == PRU_BIND || so == NULL)
-		return (&udp_thread[0].td_msgport);
-
-	inp = so->so_pcb;
-
-#ifndef RSS
-	if (IN_MULTICAST(ntohl(inp->inp_laddr.s_addr)))
-		return (&udp_thread[0].td_msgport);
-#endif
-
-	/*
-	 * Rely on type-stable memory and check in protocol handler
-	 * to fix race condition here w/ deallocation of inp.  XXX JH
-	 */
+	return(&udp_thread[0].td_msgport);
+}
 
-	return (&udp_thread[INP_MPORT_HASH_UDP(inp->inp_faddr.s_addr,
-	    inp->inp_laddr.s_addr, inp->inp_fport, inp->inp_lport)].td_msgport);
+/*
+ * This is used to map a socket to a message port for sendmsg() and friends.
+ * It is not called for any other purpose.
+ *
+ * In the case of UDP we just return the port already installed in the socket,
+ * regardless of what (nam) is.
+ */
+lwkt_port_t
+udp_soport(struct socket *so, struct sockaddr *nam,
+	   struct mbuf **dummy __unused)
+{
+	return(so->so_port);
 }
 
 /*
diff --git a/sys/netinet/ip_divert.c b/sys/netinet/ip_divert.c
index 5b1afc6..5293c27 100644
--- a/sys/netinet/ip_divert.c
+++ b/sys/netinet/ip_divert.c
@@ -159,17 +159,12 @@ div_input(struct mbuf *m, ...)
 }
 
 struct lwkt_port *
-div_soport(struct socket *so, struct sockaddr *nam,
-	   struct mbuf **mptr, int req)
+div_soport(struct socket *so, struct sockaddr *nam, struct mbuf **mptr)
 {
 	struct sockaddr_in *sin;
 	struct mbuf *m;
 	int dir;
 
-	/* Except for send(), everything happens on CPU0 */
-	if (req != PRU_SEND)
-		return cpu0_soport(so, nam, mptr, req);
-
 	sin = (struct sockaddr_in *)nam;
 	m = *mptr;
 	M_ASSERTPKTHDR(m);
@@ -484,6 +479,7 @@ div_attach(struct socket *so, int proto, struct pru_attach_info *ai)
 	 * The socket is always "connected" because
 	 * we always know "where" to send the packet.
 	 */
+	so->so_port = cpu0_soport(so, NULL, NULL);
 	so->so_state |= SS_ISCONNECTED;
 	return 0;
 }
diff --git a/sys/netinet/ip_divert.h b/sys/netinet/ip_divert.h
index 8d7d231..f029e31 100644
--- a/sys/netinet/ip_divert.h
+++ b/sys/netinet/ip_divert.h
@@ -51,8 +51,7 @@ struct divert_info {
 void	div_init(void);
 void	div_input(struct mbuf *, ...);
 struct lwkt_port *
-	div_soport(struct socket *, struct sockaddr *,
-		   struct mbuf **, int);
+	div_soport(struct socket *, struct sockaddr *, struct mbuf **);
 
 extern struct mbuf *(*ip_divert_p)(struct mbuf *, int, int);
 
diff --git a/sys/netinet/ip_flow.c b/sys/netinet/ip_flow.c
index 1e4ca1e..7603027 100644
--- a/sys/netinet/ip_flow.c
+++ b/sys/netinet/ip_flow.c
@@ -558,8 +558,8 @@ ipflow_ifaddr(void *arg __unused, struct ifnet *ifp __unused,
 		return;
 	}
 
-	netmsg_init(&amsg.ipf_nmsg, &curthread->td_msgport, MSGF_PRIORITY,
-		    ipflow_ifaddr_handler);
+	netmsg_init(&amsg.ipf_nmsg, NULL, &curthread->td_msgport,
+		    MSGF_PRIORITY, ipflow_ifaddr_handler);
 	amsg.ipf_addr = ifatoia(ifa)->ia_addr.sin_addr;
 
 	ifnet_domsg(&amsg.ipf_nmsg.nm_lmsg, 0);
@@ -572,7 +572,7 @@ ipflow_init(void)
 	int i;
 
 	for (i = 0; i < ncpus; ++i) {
-		netmsg_init(&ipflow_timo_netmsgs[i], &netisr_adone_rport,
+		netmsg_init(&ipflow_timo_netmsgs[i], NULL, &netisr_adone_rport,
 			    MSGF_MPSAFE, ipflow_timo_dispatch);
 
 		ksnprintf(oid_name, sizeof(oid_name), "inuse%d", i);
diff --git a/sys/netinet/ip_input.c b/sys/netinet/ip_input.c
index 4e209fc..fe74292 100644
--- a/sys/netinet/ip_input.c
+++ b/sys/netinet/ip_input.c
@@ -936,8 +936,8 @@ DPRINTF(("ip_input: no SP, packet discarded\n"));/*XXX*/
 			return;
 
 		pmsg = &m->m_hdr.mh_netmsg;
-		netmsg_init(&pmsg->nm_netmsg, &netisr_apanic_rport, MSGF_MPSAFE,
-			    transport_processing_handler);
+		netmsg_init(&pmsg->nm_netmsg, NULL, &netisr_apanic_rport,
+			    MSGF_MPSAFE, transport_processing_handler);
 		pmsg->nm_packet = m;
 		pmsg->nm_netmsg.nm_lmsg.u.ms_result = hlen;
 
diff --git a/sys/netinet/tcp_subr.c b/sys/netinet/tcp_subr.c
index 5918407..fa69e31 100644
--- a/sys/netinet/tcp_subr.c
+++ b/sys/netinet/tcp_subr.c
@@ -1028,8 +1028,8 @@ no_valid_rt:
 		cpu = (inp->inp_pcbinfo->cpu + 1) % ncpus2;
 		msg = kmalloc(sizeof(struct netmsg_remwildcard),
 			      M_LWKTMSG, M_INTWAIT);
-		netmsg_init(&msg->nm_netmsg, &netisr_afree_rport, 0,
-			    in_pcbremwildcardhash_handler);
+		netmsg_init(&msg->nm_netmsg, NULL, &netisr_afree_rport,
+			    0, in_pcbremwildcardhash_handler);
 #ifdef INET6
 		msg->nm_isinet6 = isafinet6;
 #endif
@@ -1117,8 +1117,8 @@ tcp_drain(void)
 				    M_LWKTMSG, M_NOWAIT);
 			if (msg == NULL)
 				continue;
-			netmsg_init(&msg->nm_netmsg, &netisr_afree_rport, 0,
-				    tcp_drain_handler);
+			netmsg_init(&msg->nm_netmsg, NULL, &netisr_afree_rport,
+				    0, tcp_drain_handler);
 			msg->nm_head = &tcbinfo[cpu].pcblisthead;
 			lwkt_sendmsg(tcp_cport(cpu), &msg->nm_netmsg.nm_lmsg);
 		}
@@ -1454,8 +1454,8 @@ tcp_ctlinput(int cmd, struct sockaddr *sa, void *vip)
 		struct netmsg_tcp_notify nmsg;
 
 		KKASSERT(&curthread->td_msgport == cpu_portfn(0));
-		netmsg_init(&nmsg.nm_nmsg, &curthread->td_msgport, 0,
-			    tcp_notifyall_oncpu);
+		netmsg_init(&nmsg.nm_nmsg, NULL, &curthread->td_msgport,
+			    0, tcp_notifyall_oncpu);
 		nmsg.nm_faddr = faddr;
 		nmsg.nm_arg = arg;
 		nmsg.nm_notify = notify;
diff --git a/sys/netinet/tcp_syncache.c b/sys/netinet/tcp_syncache.c
index 129c991..0f7e77f 100644
--- a/sys/netinet/tcp_syncache.c
+++ b/sys/netinet/tcp_syncache.c
@@ -337,8 +337,8 @@ syncache_init(void)
 			syncache_percpu->mrec[i].msg.nm_mrec =
 			    &syncache_percpu->mrec[i];
 			netmsg_init(&syncache_percpu->mrec[i].msg.nm_netmsg,
-				    &syncache_null_rport, 0,
-				    syncache_timer_handler);
+				    NULL, &syncache_null_rport,
+				    0, syncache_timer_handler);
 		}
 	}
 
@@ -628,6 +628,8 @@ syncache_unreach(struct in_conninfo *inc, struct tcphdr *th)
 
 /*
  * Build a new TCP socket structure from a syncache entry.
+ *
+ * This is called from the context of the SYN+ACK
  */
 static struct socket *
 syncache_socket(struct syncache *sc, struct socket *lso, struct mbuf *m)
@@ -635,6 +637,7 @@ syncache_socket(struct syncache *sc, struct socket *lso, struct mbuf *m)
 	struct inpcb *inp = NULL, *linp;
 	struct socket *so;
 	struct tcpcb *tp;
+	lwkt_port_t port;
 #ifdef INET6
 	const boolean_t isipv6 = sc->sc_inc.inc_isipv6;
 #else
@@ -657,11 +660,16 @@ syncache_socket(struct syncache *sc, struct socket *lso, struct mbuf *m)
 		goto abort;
 	}
 
-	inp = so->so_pcb;
+	/*
+	 * Set the protocol processing port for the socket to the current
+	 * port (that the connection came in on).
+	 */
+	sosetport(so, &curthread->td_msgport);
 
 	/*
 	 * Insert new socket into hash list.
 	 */
+	inp = so->so_pcb;
 	inp->inp_inc.inc_isipv6 = sc->sc_inc.inc_isipv6;
 	if (isipv6) {
 		inp->in6p_laddr = sc->sc_inc.inc6_laddr;
@@ -749,6 +757,18 @@ syncache_socket(struct syncache *sc, struct socket *lso, struct mbuf *m)
 		}
 	}
 
+	/*
+	 * The current port should be in the context of the SYN+ACK and
+	 * so should match the tcp address port.
+	 */
+	if (isipv6) {
+		port = tcp6_addrport();
+	} else {
+		port = tcp_addrport(inp->inp_faddr.s_addr, inp->inp_fport,
+				    inp->inp_laddr.s_addr, inp->inp_lport);
+	}
+	KKASSERT(port == &curthread->td_msgport);
+
 	tp = intotcpcb(inp);
 	tp->t_state = TCPS_SYN_RECEIVED;
 	tp->iss = sc->sc_iss;
diff --git a/sys/netinet/tcp_timer.c b/sys/netinet/tcp_timer.c
index 9dac7fd..ff0d99d 100644
--- a/sys/netinet/tcp_timer.c
+++ b/sys/netinet/tcp_timer.c
@@ -700,7 +700,7 @@ tcp_create_timermsg(struct tcpcb *tp, struct lwkt_port *msgport)
 {
 	struct netmsg_tcp_timer *tmsg = tp->tt_msg;
 
-	netmsg_init(&tmsg->tt_nmsg, &netisr_adone_rport,
+	netmsg_init(&tmsg->tt_nmsg, NULL, &netisr_adone_rport,
 		    MSGF_DROPABLE | MSGF_PRIORITY, tcp_timer_handler);
 	tmsg->tt_cpuid = mycpuid;
 	tmsg->tt_msgport = msgport;
